SystemOrganization addCategory: #'GBT-DSL_GC_Program'!

Object subclass: #GCContexts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Program'!

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 11/14/2016 18:07'!
gcActivitiesContext: userName  
	^GbtBigListAC  newStruct: 'GCActivitiesContext'  for: userName define: { 
		{#displayAs: . 'Activities' }.
		{#noPolicyGetter: . #alphaSmallID}.
		{#uiSpec:icon: . #GbtListUI . #activity16}.
		{#templates: . GCBizProcess bizActivities }.
		{#subcontext: . self gcActivityContext: userName  } .
	}
		
! !

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 12/14/2016 16:55'!
gcActivityContext: userName  
	^GbtPlainAC  newStruct: 'GCActivityContext'  for: userName define: { 
		{#displayAs: . 'Activity' }.
		{#uiSpec:icon: . #GbtItemUI . #activity16}.
	}
		
! !

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 12/16/2016 18:29'!
gcBizProcessContext: userName  
	
	^GbtPlainAC newStruct: 'GCBizProcessContext' for: userName  define: { 
		{ #displayAs:  .'Biz Process'  } .
		{ #uiSpec:icon: . #GbtItemWithTabsUI . #bizProcesses} .
		{ #blackboardAspect:on: . GCContexts gcServiceDataContext: userName . #bizProcessServiceData } .
		{ #aspect:on: . GCContexts gcCustomerContext: userName . #bizCustomer } .
		{ #aspect:on: . GCContexts gcRequestContext: userName . #bizRequest } .
		{ #aspect:on: . GCContexts gcOfferContext: userName . #bizOffer } .
		{ #aspect:on: . GCContexts gcOrderContext: userName . #bizOrder } .
		{ #aspect:on: . GCContexts gcActivitiesContext: userName . #bizActivities } .

		{#menu:items: . #BizNet . #(#'Confirm Request' #'Send Offer' #'Confirm Order') }.
		{#menu:items: . #ServiceData . #(#'From Request' #'From Offer' #'From Order') }.
		{#behavior:actions: . #'Confirm Request' . #(COMPOSE GCBizNetConfirmRequest SENDTO #(bizCustomer company))}. 
		{#behavior:actions: . #'Confirm Order' . #(COMPOSE GCBizNetConfirmOrder SENDTO #(bizCustomer company))}.
		{#behavior:actions: . #'Send Offer' . #(COMPOSE GCBizNetOffer SENDTO #(bizCustomer company))}.

		{#behavior:actions: . #'From Request' . #(
			READSLOT #(bizRequestServiceData v1)
			WRITESLOT #(v1 bizProcessServiceData)
			ASSIGNVAL #(bizProcess aspectStatus))}.
		{#behavior:reuse:modify: . #'From Offer' . #'From Request' . #(
			READSLOT #(bizOfferServiceData v1) ) }.
		{#behavior:reuse:modify: . #'From Order' . #'From Request' . #(
			READSLOT #(bizOrderServiceData v1) ) }.
 	}  ! !

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 11/14/2016 18:09'!
gcBizProcessesContext: userName  

	^GbtBigListAC newStruct: 'GCBizProcessesContext'  for: userName define: {
		{#displayAs: . 'Biz Processes'  }.
		{#noPolicyPrefix: . 'BizP'}.
		{#uiSpec:icon: . #GbtListUI . #bizProcesses}.
		{#templates: . GCBizProcess bizProcess }.
		{#display: . #( #(majorServiceType processType) firstName lastName company #(bizProcessOwnership owner) #(gcDate created)) }.
		{#subcontext: . GCContexts gcBizProcessContext: userName  }.
		
		{#onReceiveDo: . #(pushRequest pushConfirmOffer pushOrder) }.
		{#behavior:actions: . #pushRequest . #(
			GETEVENT GCBizNetRequest 
			MATCH #(thing bizProcessBizId) 
			EMBED #(thing GCBizNetConfirmRequest) 
			CONTEXT GCRequestContext 
			ASSUREVO void
			CONSTRAINTS #(processId customer aspectProcessBizId))}.
		{#behavior:reuse:modify: . #pushConfirmOffer . #pushRequest . #(
			GETEVENT GCBizNetConfirmOffer 
			EMBED #(thing GCBizNetOffer )
			CONTEXT GCOfferContext )}.
		{#behavior:reuse:modify: . #pushOrder . #pushRequest . #(
			GETEVENT GCBizNetOrder 
			EMBED #(thing GCBizNetConfirmOrder )
			CONTEXT GCOrderContext )}.
	}	! !

!GCContexts class methodsFor: 'main context' stamp: 'hk 11/7/2016 17:06'!
gcCalcContext: userName  
	^GbtBigListAC newStruct: 'GCCalcContext'  for: userName define: {
		{#displayAs: . 'Calculator'  } .
		{#uiSpec:icon:  . #GcCalcUI . #userSettings}} ! !

!GCContexts class methodsFor: 'contact contexts' stamp: 'hk 12/16/2016 18:29'!
gcContactContext: userName  
	^GbtPlainAC newStruct: 'GCContactContext'  for: userName define: {
		{#displayAs: . 'Contact'  } .
		{#uiSpec:icon: . #GbtItemUI . #contacts} .
		
		{#menu: . #email }.
		{#behavior:actions: . #email . #(READSLOT #(eMail v1) CONTEXT GCEmailContext WRITESLOT #(v1 emailAddr) EDIT v1)}.
	}! !

!GCContexts class methodsFor: 'contact contexts' stamp: 'hk 11/14/2016 18:08'!
gcContactsContext: userName  
	^GbtBigListAC newStruct: 'GCContactsContext'  for: userName define: {
		{#displayAs: . 'Contacts'  } .
		{#noPolicyPrefix: . 'Cont'}.
		{#uiSpec:icon: . #GbtListUI . #contacts} .
		{#templates: . GCContact contact } .
		{#display: . #(firstName lastName company) } .
		{#subcontext: . self gcContactContext: userName  } .

		{#onReceiveDo: . #(attach) }.
		{#behavior:actions: . #attach . #(GETEVENT GCContact TOLIST thing)}.
	}! !

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 11/14/2016 18:09'!
gcCustomerContext: userName  
	^GbtPlainAC newStruct: 'GCCustomerContext' for: userName  define:  {
		{#displayAs: . 'Customer' } .
		{#uiSpec:icon: . #GbtAspectUI . #contacts} .
		{#chooseWith: . GCContexts gcContactsContext: userName } .
		{ #voChange: . #addOnly }.
	}	
! !

!GCContexts class methodsFor: 'main context' stamp: 'hk 11/7/2016 17:07'!
gcDashContext: userName  
	^GbtBigListAC newStruct: 'GCDashContext'  for: userName define: {  
		{#displayAs: . 'Dash Board'  } .
		{#uiSpec:icon: . #GcDashUI . #dash} 
	}! !

!GCContexts class methodsFor: 'main context' stamp: 'hk 11/7/2016 17:07'!
gcEmailContext: userName  
	^GbtPlainAC newStruct: 'GCEmailContext' for: userName  define: {
		{#displayAs: . 'Email'  } .
		{#uiSpec:icon: . #GbtItemUI . #email} .
		{#vo: . GbtApplicationTest eMail } .
	}! !

!GCContexts class methodsFor: 'main context' stamp: 'hk 11/8/2016 20:07'!
gcLoginContext
	^ GbtLoginAC newStruct: 'GCLogin' for: '' define:
			{{#uiSpec:icon: . nil . #header}.
			{#displayAs: . #'Inside Transport'}.
			{#appClass:selector: . #GCContexts . #gcMainContext:}.
			{#legalText: . 'GloConn International © 2016'}}! !

!GCContexts class methodsFor: 'main context' stamp: 'hk 11/18/2016 11:02'!
gcMainContext: arg1

	^ GbtPlainAC newStruct: 'GCMainContext' for: arg1 define:
			{{#aspect:on:. (GCContexts gcContactsContext: arg1). nil}.
			{#aspect:on:. (GCContexts gcBizProcessesContext: arg1). nil}.
			{#aspect:on:. (GCContexts gcTaskOrdersContext: arg1). nil}.
			{#aspect:on:. (GCContexts gcSupplierBizProcessesContext: arg1). nil}.
			{#aspect:on:. (GCContexts gcDashContext: arg1). nil}.
			{#aspect:on:. (GCContexts gcCalcContext: arg1). nil}.
			{#uiSpec:icon: . #GbtGloConnMainUI . #header}.
			{#displayAs: . 'Inside Transport'}.
			{#legalText: . 'GloConn International © 2016'}.
			{#onReceiveDo:. #(#pushCust #pushOffer #pushRequest #pushOrder #pushConfirmRequest #pushConfirmOffer #pushConfirmOrder)}.
			{#behavior:actions:. #pushCust. #(#GETEVENT #GCContact #PUSHTO #GCContactsContext)}.
			{#behavior:actions:. #pushRequest. #(#GETEVENT #GCBizNetRequest #PUSHTO #GCBizProcessesContext)}. 
			{#behavior:actions:. #pushConfirmOffer. #(#GETEVENT #GCBizNetConfirmOffer #PUSHTO #GCBizProcessesContext)}.
			{#behavior:actions:. #pushOrder. #(#GETEVENT #GCBizNetOrder #PUSHTO #GCBizProcessesContext)}.
			{#behavior:actions:. #pushConfirmRequest. #(#GETEVENT #GCBizNetConfirmRequest #PUSHTO #GCSupplierBizProcessesContext)}.
			{#behavior:actions:. #pushOffer. #(#GETEVENT #GCBizNetOffer #PUSHTO #GCSupplierBizProcessesContext)}.
			{#behavior:actions:. #pushConfirmOrder. #(#GETEVENT #GCBizNetConfirmOrder #PUSHTO #GCSupplierBizProcessesContext)}}! !

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 12/16/2016 18:30'!
gcOfferContext: userName  
	^GbtPlainAC newStruct: 'GCOfferContext'  for: userName define: { 
		{#displayAs: . 'Offer' } .
		{#noPolicyPrefix: . 'OF'}.
		{#uiSpec:icon: . #GbtAspectUI . #bizoffer16}.
		{#voChange: . #addyRemove }.
		{#templates: . {GCBizProcess  bizOffer . IntegrationTestThings bizOffer1} } .
		{#blackboardSlot: . #bizOfferServiceData }.

		{#createBehaviors: . #( serviceData serviceDataAspect) }.
		{#behavior:actions: . #serviceData . #(
			CONTEXT GCBizProcessContext 
			READSLOT #(bizProcessServiceData v1)
			CONTEXT GCOfferContext 
			WRITESLOT #(v1 bizOfferServiceData))}.
		{#behavior:actions: . #serviceDataAspect . #(
			READSLOT #(bizOfferServiceData thing)
			ASSIGNVAL #(offer aspectStatus) )}.

 		{#constraints: . #( aspectProcessBizId processId customer supplier ) } .
		{#constraint:left:right: . #processId . #(CONTEXT GCBizProcessContext SLOT bizId ) . #(SLOT bizProcessBizId)}.
		{#constraint:left:right: . #customer . #(CONTEXT GCBizProcessContext SLOT bizCustomer ) . #(SLOT bizOfferCustomer)}.
		{#constraint:left:right: . #supplier . #(CONTEXT GCMainContext SLOT activeServiceAgent) . #(SLOT bizOfferSupplier)}.
		{#constraint:left:right: . #aspectProcessBizId . #(CONTEXT GCBizProcessContext SLOT aspectProcessBizId) . #(SLOT aspectProcessBizId)}.
	}
! !

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 12/16/2016 18:30'!
gcOrderContext: userName  
	^GbtPlainAC newStruct: 'GCOrderContext'  for: userName define: { 
		{#displayAs: . 'Order'} .
		{#noPolicyPrefix: . 'ORD'}.
		{#uiSpec:icon: . #GbtAspectUI . #bizorder16}.
		{#templates: . {GCBizProcess  bizOrder} }.
		{#voChange: . #addyRemove }.
		{#blackboardSlot: . #bizOrderServiceData }.

		{#createBehaviors: . #( serviceData serviceDataAspect) }.
		{#behavior:actions: . #serviceData . #(
			CONTEXT GCBizProcessContext 
			READSLOT #(bizProcessServiceData v1)
			CONTEXT GCOrderContext 
			WRITESLOT #(v1 bizOrderServiceData))}.
		{#behavior:actions: . #serviceDataAspect . #(
			READSLOT #(bizOrderServiceData thing)  
			ASSIGNVAL #(order aspectStatus))}.
		
		{#constraints: . #(aspectProcessBizId processId customer supplier ) } .
		{#constraint:left:right: . #processId . #(CONTEXT GCBizProcessContext SLOT bizId ) . #(SLOT bizProcessBizId)}.
		{#constraint:left:right: . #customer . #(CONTEXT GCBizProcessContext SLOT bizCustomer ) . #(SLOT bizOrderCustomer)}.
		{#constraint:left:right: . #supplier . #(CONTEXT GCMainContext SLOT activeServiceAgent) . #(SLOT bizOrderSupplier)}.
		{#constraint:left:right: . #aspectProcessBizId . 	#(CONTEXT GCBizProcessContext SLOT aspectProcessBizId) . #(SLOT aspectBizId)}.
	}
	
! !

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 12/16/2016 18:30'!
gcRequestContext: userName  
	^GbtPlainAC newStruct: 'GCRequestContext'  for: userName define: {
		{#displayAs:  .'Request' } .
		{#uiSpec:icon: . #GbtAspectUI . #bizrequest16}.
		{#voChange: . #addyRemove }.
		{#templates: . GCBizProcess bizRequest } .
		{#blackboardSlot: . #bizRequestServiceData }.
				
		{#createBehaviors: . #( serviceData serviceDataAspect) }.
		{#behavior:actions: . #serviceData . #(
			CONTEXT GCBizProcessContext 
			READSLOT #(bizProcessServiceData v1)
			CONTEXT GCRequestContext 
			WRITESLOT #(v1 bizRequestServiceData))}.
		{#behavior:actions: . #serviceDataAspect . #(
			READSLOT #(bizRequestServiceData thing)  
			ASSIGNVAL #(request aspectStatus))}.
			
		{#constraints: . #( processId customer supplier aspectProcessBizId) } .
		{#constraint:left:right: . #processId . #(CONTEXT GCBizProcessContext SLOT bizId) . #(SLOT bizProcessBizId)}.
		{#constraint:left:right: . #customer . #(CONTEXT GCBizProcessContext SLOT bizCustomer ) . #(SLOT bizRequestCustomer)}.
		{#constraint:left:right: . #supplier . #(CONTEXT GCMainContext SLOT activeServiceAgent) . #(SLOT bizRequestSupplier)}.
		{#constraint:left:right: . #aspectProcessBizId . #(CONTEXT GCBizProcessContext SLOT aspectProcessBizId) . #(SLOT aspectProcessBizId)}.
 	} ! !

!GCContexts class methodsFor: 'process contexts' stamp: 'hk 11/14/2016 18:07'!
gcServiceDataContext: userName  
	| template |
	template := GCServiceData  serviceData .
	template serviceDataItems newEntry: IntegrationTestThings serviceDataItemTransport_BtoHB_2Items.
	
	^GbtPlainAC newStruct: 'GCServiceDataContext'  for: userName define: { 
		{#displayAs: . 'Service Data'  }.
		{#noPolicyPrefix: . 'SD'}.
		{#uiSpec:icon: . #GbtAspectUI . #servicedata16}.
		{ #voChange: . #addyRemove }.
		{#templates: . {template . GCServiceData  serviceData} } .
	}! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 11/7/2016 19:16'!
gcSupplierBizProcessContext: userName  
	^GbtPlainAC newStruct: 'GCSupplierBizProcessContext'  for: userName define: {
		{#displayAs: . 'Supplier BizProcess'  } .
		{#display: . #(supplierBizProcessType supplierBizProcessOwnership supplierBizProcessStatus ) }.
		{#uiSpec:icon: . #GbtItemWithTabsUI . #supplierBizProcesses} .
		{#aspect:on: . self gcSuppliersServiceDataContext: userName . #supplierServiceData } .
		{#aspect:on: . self gcSupplierBizSubProcessesContext: userName . #supplierBizSubProcesses } 
	}! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 11/14/2016 18:07'!
gcSupplierBizProcessesContext: userName  
	^GbtBigListAC newStruct: 'GCSupplierBizProcessesContext' for: userName  define: { 
		{#displayAs: . 'Supplier BizProcesses'  } .
		{#display: . #( #(majorServiceType processType) #(issueDate created) supplierBizProcessStatus ) }.
		{#noPolicyPrefix: . 'SupP'}.
		{#uiSpec:icon: . #GbtListUI . #supplierBizProcesses} . 
		{#templates: . GCSupplierBizProcess supplierBizProcess } .
		{#subcontext: . GCContexts gcSupplierBizProcessContext: userName } .

		{#onReceiveDo: . #(pushConfirmRequest pushOffer pushConfirmOrder) }.
		{#behavior:actions: . #pushConfirmRequest . #(
			GETEVENT GCBizNetConfirmRequest 
			MATCH #(thing supplierProcessBizId) 
			PUSHTO GCSupplierBizSubProcessesContext)}.
		{#behavior:reuse:modify: . #pushOffer . #pushConfirmRequest . #(GETEVENT GCBizNetOffer )}.	
		{#behavior:reuse:modify: . #pushConfirmOrder . #pushConfirmRequest . #(GETEVENT GCBizNetConfirmOrder)}.	
	}
	
 ! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 12/16/2016 18:30'!
gcSupplierBizSubProcessContext: userName  
	^GbtPlainAC newStruct: 'GCSupplierBizSubProcessContext'  for: userName define: { 
		{#displayAs: . 'Supplier BizSubprocess' }.
		{#display: . #( supplierBizProcessId gcDate company firstName lastName bizProcessOwner) }.
		{#uiSpec:icon: . #GbtItemWithTabsUI . #supplierBizSubProcesses}.		
		{#blackboardAspect:on: . self gcSupplierServiceDataContext: userName .  #supplierSubProcessServiceData } .
		{#aspect:on: . self gcSupplierContactContext: userName . #bizSupplier }.
		{#aspect:on: . self gcSupplierRequestContext: userName . #supplierBizRequest }.
		{#aspect:on: . self gcSupplierOfferContext: userName . #supplierBizOffer }.
		{#aspect:on: . self gcSupplierOrderContext: userName . #supplierBizOrder } .

		{#createBehaviors: . #( serviceData processBizId agent) }.
		{#behavior:actions: . #serviceData . #(
			CONTEXT GCSupplierBizProcessContext
			READSLOT #(supplierServiceData v1) 
			CONTEXT GCSupplierBizSubProcessContext 
			WRITESLOT #(v1 supplierSubProcessServiceData))}.		
		{#behavior:reuse:modify:  . #processBizId . #serviceData . #(
			READSLOT #(bizId v1)
			WRITESLOT #(v1 supplierBizProcessId))}.		
		{#behavior:reuse:modify: . #agent . #serviceData . #(
			CONTEXT GCMainContext 
			READSLOT #(activeServiceAgent v1)
			WRITESLOT #(v1 bizCustomer))}.		
		
		{#menu:items: . #BizNet . #(SendRequest ConfirmOffer SendOrder) }.
		{#menu:items: . #ServiceData . #(FromRequest FromOffer FromOrder) }.
		
		{#behavior:actions: . #SendRequest . #(COMPOSE GCBizNetRequest SENDTO #(bizSupplier company))}.
		{#behavior:actions: . #ConfirmOffer . #(COMPOSE GCBizNetConfirmOffer SENDTO #(bizSupplier company))}.
		{#behavior:actions: . #SendOrder . #(COMPOSE GCBizNetOrder SENDTO #(bizSupplier company))}.
		
		{#behavior:actions: . #FromRequest . #(
			READSLOT #(supplierBizRequest bizRequestServiceData v1)
			WRITESLOT #(v1 supplierSubProcessServiceData) 
			ASSIGNVAL #(bizProcess aspectStatus))}.
		{#behavior:reuse:modify: . #FromOffer . #FromRequest . #(READSLOT #(supplierBizOffer bizOfferServiceData v1) )}.
		{#behavior:reuse:modify: . #FromOrder . #FromRequest . #(READSLOT #(supplierBizOrder bizOrderServiceData v1) )}.

	}
! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 11/14/2016 18:07'!
gcSupplierBizSubProcessesContext: userName  
	^GbtUlistAC newStruct: 'GCSupplierBizSubProcessesContext' for: userName  define: { 
		{#displayAs: . 'Supplier BizSubprocesses' }.
		{#display: . #( supplierBizProcessId gcDate company firstName lastName bizProcessOwner) }.
		{#noPolicyGetter: . #alphaCapID}.
		{#uiSpec:icon: . #GbtListUI . #supplierBizSubProcesses}.
		{#template:for: . GCSupplierBizProcess supplierBizSubProcess . #supplierBizSubProcesses}.			
		{#chooseFor: . #bizSupplier }.
		{#chooseWith: . self gcContactsContext: userName }.
		{#subcontext: . self gcSupplierBizSubProcessContext: userName }.

		{#onReceiveDo: . #(pushConfirmRequest pushOffer pushConfirmOrder) }.
		{#behavior:actions: . #pushConfirmRequest . #(
			GETEVENT GCBizNetConfirmRequest 
			MATCH #(thing supplierSubProcessBizId) 
			EMBED #(thing GCBizNetRequest)
			CONTEXT GCSupplierRequestContext 
			ASSUREVO void
			BEHAVIORS #(bizProcessBizId)
			CONSTRAINTS #(supplier "supplierBizId customerBizId" supplierBizProcessId supplierSubProcessId ) )}.
		{#behavior:reuse:modify: . #pushOffer . #pushConfirmRequest . #(
			GETEVENT GCBizNetOffer 
			EMBED #(thing GCBizNetConfirmOffer)
			CONTEXT GCSupplierOfferContext)}.	
		{#behavior:reuse:modify: . #pushConfirmOrder . #pushConfirmRequest . #(
			GETEVENT GCBizNetConfirmOrder 
			EMBED #(thing GCBizNetOrder)
			CONTEXT GCSupplierOrderContext )}.	
	}! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 11/7/2016 17:10'!
gcSupplierContactContext: userName  
	^GbtPlainAC newStruct: 'GCSupplierContactContext'  for: userName define: { 
		{#displayAs: . 'Supplier' }.
		{#uiSpec:icon: . #GbtAspectUI . #contacts}.
					
		{#constraints: . #(supplierBizId) } .
		{#constraint:left:right: . #supplierBizId . #(SLOT bizId) . #(CONTEXT GCSupplierBizSubProcessContext SLOT supplierBizId)} }! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 12/16/2016 18:30'!
gcSupplierOfferContext: userName  
	^GbtPlainAC newStruct: 'GCSupplierOfferContext'  for: userName define: {
		{#displayAs: . 'Supplier Offer'  }.
		{#uiSpec:icon: . #GbtAspectUI . #bizoffer16}.
		{ #voChange: . #addyRemove }.
		{#templates: . {GCBizProcess  bizOffer . IntegrationTestThings bizOffer1} }. 	
		{#blackboardSlot: . #bizOfferServiceData }.

		{#createBehaviors: . #( serviceDataR processConstraints serviceDataAspect) }.	
		{#behavior:actions: . #serviceDataR . #(
			CONTEXT GCSupplierBizSubProcessContext 
			READSLOT #(supplierSubProcessServiceData v1)
			CONTEXT GCSupplierOfferContext 
			WRITESLOT #(v1 bizOfferServiceData))}.		
		{#behavior:actions: . #processConstraints . #(CONSTRAINTS #(supplier supplierBizProcessId supplierSubProcessId) )}.
		{#behavior:actions: . #serviceDataAspect . #(READSLOT #(bizOfferServiceData thing)  ASSIGNVAL #(offer aspectStatus))}.

		{#behavior:actions: . #bizProcessBizId . #(
			READSLOT #(bizProcessBizId v1)
			CONTEXT GCSupplierBizSubProcessContext 
			WRITESLOT #(v1 bizProcessBizId))}.

		{#constraints: . #( customer offerSD supplierBizId customerBizId aspectProcessBizId) } .
		{#constraint:left:right: . #customer . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizCustomer ) . #(SLOT bizOfferCustomer )}.
		{#constraint:left:right: . #offerSD . #(CONTEXT GCSupplierBizSubProcessContext SLOT subProcessServiceData ) . #(SLOT bizOfferServiceData )}.	
		{#constraint:left:right: . #supplierBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT supplierBizId)}.
		{#constraint:left:right: . #customerBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT customerBizId)}.

		{#constraint:left:right: . #supplier . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizSupplier ) . #(SLOT bizOfferSupplier)}.
		{#constraint:left:right: . #supplierBizProcessId . #(CONTEXT GCSupplierBizSubProcessContext SLOT supplierBizProcessId) . #(SLOT supplierProcessBizId)}.
		{#constraint:left:right: . #supplierSubProcessId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT supplierSubProcessBizId)}.

		{#constraint:left:right: . #aspectProcessBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT aspectProcessBizId) . #(SLOT aspectProcessBizId)}.
	}
			
		
	


! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 11/7/2016 17:11'!
gcSupplierOrderAckContext: userName  
	^GbtPlainAC newStruct: 'GCSupplierOrderAckContext'  for: userName define: { 
		{#displayAs: . 'Supplier Order Acknowledge' }
	}! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 12/16/2016 18:30'!
gcSupplierOrderContext: userName  
	^GbtPlainAC newStruct: 'GCSupplierOrderContext' for: userName  define: { 
		{#displayAs: . 'Supplier Order' }.
		{#uiSpec:icon: . #GbtAspectUI . #bizorder16}.
		{ #voChange: . #addyRemove }.
		{#templates: . {GCBizProcess  bizOrder } }.
		{#blackboardSlot: . #bizOrderServiceData }.

		{#createBehaviors: . #( serviceDataR processConstraints serviceDataAspect) }.	
		{#behavior:actions: . #serviceDataR . #(
			CONTEXT GCSupplierBizSubProcessContext 
			READSLOT #(supplierSubProcessServiceData v1)
			CONTEXT GCSupplierOrderContext 
			WRITESLOT #(v1 bizOrderServiceData))}.		
 		{#behavior:actions: . #processConstraints . #(CONSTRAINTS #(supplier supplierBizProcessId supplierSubProcessId) )}.
		{#behavior:actions: . #serviceDataAspect . #(READSLOT #(bizOrderServiceData thing)  ASSIGNVAL #(order aspectStatus))}.

		{#behavior:actions: . #bizProcessBizId . #(READSLOT #(bizProcessBizId v1) CONTEXT GCSupplierBizSubProcessContext WRITESLOT #(v1 bizProcessBizId))}.

		{#constraints: . #( customer orderSD supplierBizId customerBizId aspectProcessBizId) } .
		{#constraint:left:right: . #customer . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizCustomer) . #(SLOT bizOrderCustomer)}.
		{#constraint:left:right: . #orderSD . #(CONTEXT GCSupplierBizSubProcessContext SLOT subProcessServiceData) . #(SLOT bizOrderServiceData)}.	
		{#constraint:left:right: . #supplierBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT supplierBizId)}.
		{#constraint:left:right: . #customerBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT customerBizId)}.

		{#constraint:left:right: . #supplier . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizSupplier) . #(SLOT bizOrderSupplier)}.
		{#constraint:left:right: . #supplierBizProcessId . #(CONTEXT GCSupplierBizSubProcessContext SLOT supplierBizProcessId) . #(SLOT supplierProcessBizId)}.
		{#constraint:left:right: . #supplierSubProcessId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT supplierSubProcessBizId)}.

		{#constraint:left:right: . #aspectProcessBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT aspectProcessBizId) . #(SLOT aspectProcessBizId)}.
	}	 ! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 12/16/2016 18:30'!
gcSupplierRequestContext: userName  
	^GbtPlainAC newStruct: 'GCSupplierRequestContext' for: userName  define: {
		{#displayAs: . 'Supplier Request' } .
		{#uiSpec:icon: . #GbtAspectUI . #bizrequest16}.
		{#voChange: . #addyRemove }.
		{#templates: . GCBizProcess bizRequest } .
		{#blackboardSlot: . #bizRequestServiceData }.

		{#createBehaviors: . #(serviceDataR processConstraints serviceDataAspect) }.
		{#behavior:actions: . #serviceDataR . #(
			CONTEXT GCSupplierBizSubProcessContext 
			READSLOT #(supplierSubProcessServiceData v1)
			CONTEXT GCSupplierRequestContext 
			WRITESLOT #(v1 bizRequestServiceData))}.
		{#behavior:actions: . #processConstraints . #(CONSTRAINTS #(supplier supplierBizProcessId supplierSubProcessId) )}.
		{#behavior:actions: . #serviceDataAspect . #(READSLOT #(bizRequestServiceData thing)  ASSIGNVAL #(request aspectStatus))}.

		{#behavior:actions: . #bizProcessBizId . #(READSLOT #(bizProcessBizId v1) CONTEXT GCSupplierBizSubProcessContext WRITESLOT #(v1 bizProcessBizId))}.
		
		{#constraints: . #( customer requestSD supplierBizId customerBizId aspectProcessBizId) } .
		{#constraint:left:right: . #customer . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizCustomer ) . #(SLOT bizRequestCustomer )}.
		{#constraint:left:right: . #requestSD . #(CONTEXT GCSupplierBizSubProcessContext SLOT subProcessServiceData ) . #(SLOT bizRequestServiceData )}.	
		{#constraint:left:right: . #supplierBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT supplierBizId)}.
		{#constraint:left:right: . #customerBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT customerBizId)}.

		{#constraint:left:right: . #supplier . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizSupplier ) . #(SLOT bizRequestSupplier)}.
		{#constraint:left:right: . #supplierBizProcessId . #(CONTEXT GCSupplierBizSubProcessContext SLOT supplierBizProcessId) . #(SLOT supplierProcessBizId)}.
		{#constraint:left:right: . #supplierSubProcessId . #(CONTEXT GCSupplierBizSubProcessContext SLOT bizId) . #(SLOT supplierSubProcessBizId)}.
		{#constraint:left:right: . #aspectProcessBizId . #(CONTEXT GCSupplierBizSubProcessContext SLOT aspectProcessBizId) . #(SLOT aspectProcessBizId)}.
	}  ! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 11/7/2016 17:11'!
gcSupplierServiceDataContext: userName  
	| template |
	template := GCServiceData  serviceData. 
	template serviceDataItems newEntry: IntegrationTestThings serviceDataItemTransport_BtoHB_2Items.
	
	^GbtPlainAC newStruct: 'GCSupplierServiceDataContext' for: userName  define: { 
		{#displayAs: . 'Service Data'  }.
		{#uiSpec:icon: . #GbtAspectUI . #servicedata16}.
		{ #voChange: . #addyRemove }.
		{#templates: . {GCServiceData  serviceData . template} } .	}! !

!GCContexts class methodsFor: 'supplierContexts' stamp: 'hk 11/7/2016 17:11'!
gcSuppliersServiceDataContext: userName  
	| template |
	template := GCServiceData  serviceData.
	template serviceDataItems newEntry: IntegrationTestThings serviceDataItemTransport_BtoHB_2Items.

	^GbtPlainAC newStruct: 'GCSuppliersServiceDataContext'  for: userName define: { 
		{#displayAs: . 'Service Data'  }.
		{#uiSpec:icon: . #GbtAspectUI . #servicedata16}.
		{ #voChange: . #addyRemove }.
		{#templates: . {template . GCServiceData  serviceData} } .
	}! !

!GCContexts class methodsFor: 'task orders' stamp: 'hk 12/14/2016 16:55'!
gcTaskOrderContext: userName  
	^GbtPlainAC newStruct: 'GCTaskOrderContext'  for: userName define: {
		{#displayAs: . 'Task Order'  } .
		{#uiSpec:icon: . #GbtItemUI . #taskOrder} 
	}! !

!GCContexts class methodsFor: 'task orders' stamp: 'hk 11/14/2016 18:07'!
gcTaskOrdersContext: userName  
	^GbtBigListAC newStruct: 'GCTaskOrdersContext'  for: userName define: {
		{#displayAs: . 'Task Orders'  } .
		{#noPolicyPrefix: . 'TO'}.
		{#uiSpec:icon: . #GbtListUI . #taskOrders} . 
		{#templates: . GCTaskOrder taskOrder } .
		{#subcontext: . self gcTaskOrderContext: userName } 
	}! !

Object subclass: #GCDeclaratives
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Program'!

!GCDeclaratives class methodsFor: 'request offer-order' stamp: 'hk 5/12/2016 16:17'!
bizNetConfirmOfferCombinator
	"self bizNetOfferCombinator edit
	bizNet names     ---      local names"
	
	^GbtDeclarative newStruct: 'GCBizNetConfirmOffer' define: { 
		{ #offer . #tag: . #supplierBizOffer  }.
	 }
! !

!GCDeclaratives class methodsFor: 'request offer-order' stamp: 'hk 5/12/2016 16:17'!
bizNetConfirmOrderCombinator
	"self bizNetGetOrderCombinator edit
	bizNet names     ---      local names"
	
	^GbtDeclarative newStruct: 'GCBizNetConfirmOrder' define: { 
		{ #order . #tag: . #bizOrder  }.
	 }! !

!GCDeclaratives class methodsFor: 'request offer-order' stamp: 'hk 5/12/2016 16:17'!
bizNetConfirmRequestCombinator
	"self bizNetConfirmRequestCombinator edit
	bizNet names     ---      local names"
	
	^GbtDeclarative newStruct: 'GCBizNetConfirmRequest' define: { 
		{ #request . #tag: . #bizRequest  }.
	 }
! !

!GCDeclaratives class methodsFor: 'request offer-order' stamp: 'hk 5/12/2016 16:17'!
bizNetOfferCombinator
	"self bizNetGetOfferCombinator edit
	bizNet names     ---      local names"
	
	^GbtDeclarative newStruct: 'GCBizNetOffer' define: { 
		{ #offer . #tag: . #bizOffer  }.
	 }! !

!GCDeclaratives class methodsFor: 'request offer-order' stamp: 'hk 5/12/2016 16:17'!
bizNetOrderCombinator
	"self bizNetOrderCombinator edit
	bizNet names     ---      local names"
	
	^GbtDeclarative newStruct: 'GCBizNetOrder' define: { 
		{ #order . #tag: . #supplierBizOrder  }.
	 }
! !

!GCDeclaratives class methodsFor: 'request offer-order' stamp: 'hk 5/12/2016 16:17'!
bizNetRequestCombinator
	"self bizNetRequestView edit
	bizNet names     ---      local names"
	
	^GbtDeclarative newStruct: 'GCBizNetRequest' define: { 
		{ #request . #tag: . #supplierBizRequest  }.
	 }! !

!GCDeclaratives class methodsFor: 'service data' stamp: 'hk 5/12/2016 16:17'!
bizNetSupplierServiceDataCombinator
	"self bizNetSupplierServiceDataCombinator edit"
	
	^GbtDeclarative newStruct: 'GCBizNetServiceData' define: { 
		{ #bizRequestServiceData  . #tag: . #supplierServiceData  }.
	 }! !

!GCDeclaratives class methodsFor: 'initialize' stamp: 'hk 6/3/2016 12:27'!
initializeInterfaceCombinators
	GCDeclaratives 
		bizNetRequestCombinator; 
		bizNetConfirmRequestCombinator ;
		bizNetSupplierServiceDataCombinator;
		bizNetOfferCombinator;
		bizNetConfirmOfferCombinator;
		bizNetOrderCombinator;
		bizNetConfirmOrderCombinator! !
